#!/tmp/.ZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZpErLZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZperl/bin/perl 
# below is a marker for the test scripts to relocate this
# file as appropriate to run under the test environment
#<<LIB>>
use strict;
use CGI;
use PureMessage::RPC::Request;
use PureMessage::RPC::Response;
use PureMessage::Config qw( %config);
use PureMessage::Manager::Lang qw( text ); 
use PureMessage::List;
use PureMessage::RPC::NamedDataEncoder;
use PureMessage::RPC::Config qw( %rpc_config );

my $CONNECTED_HOST = $ENV{'REMOTE_HOST'} || $ENV{'REMOTE_ADDR'};
my $cgi   = new CGI;
my %input = $cgi->Vars();
my $debug = $input{debug};
my $BASE_64 = 0;
my $ACCESS_LIST;
my $nd = PureMessage::RPC::NamedDataEncoder->new();

if ($debug) {
 print $cgi->header();
 print "<PRE>\n";
} else {
 $BASE_64 = 1 if $ENV{'HTTP_ACCEPT'} =~ m|text/csv_b64|;
}

$PureMessage::RPC::Response::USE_BASE64_ENCODED = $BASE_64;


# get our RPC path
my $path  = $cgi->path_info();
$path =~ s|^/||;
my ($mod,@args) = split('/',$path);
PureMessage::Manager::Lang::set_namespace("/RPC/$mod"); # for our lang entries

my $rq = new PureMessage::RPC::Request(nobuffer=>1);
$rq->log(text('rpc_connect',$CONNECTED_HOST,$path));

# get any posted data
if ($input{DATA}) {
  my @data = split("\0",$input{DATA});
  foreach my $data_line (@data) {
    my ($arg,$errors) = $nd->parse_named_line($data_line);
    if(exists($arg->{arg})) {
      my @a = ref($arg->{arg}) eq 'ARRAY' ? @{$arg->{arg}} : ($arg->{arg});
      push(@args,@a);
    }
  }
}

eval {
  $ACCESS_LIST = PureMessage::List->new($rpc_config{allow}->{hosts});
};
if ($@) {
    $rq->log_error(text('rpc_access_list_fail',$@));
    # we cannot continue!
    $rq->dispatch_error(text('rpc_host_denied',$CONNECTED_HOST));
    exit;
}

if ($ACCESS_LIST and !$ACCESS_LIST->match($CONNECTED_HOST)) {
    $rq->log_error(text('rpc_access_fail',$CONNECTED_HOST));
    # we cannot continue!
    $rq->dispatch_error(text('rpc_host_denied',$CONNECTED_HOST));
    exit;
}
my $o = $rq->call($mod,@args);

if ($debug) {
  print "</PRE>\n";
}

# suitable apache conf to make this work nicely

#<VirtualHost 192.168.90.1>
#    ServerAdmin root@localhost
#    DocumentRoot /opt/pmx5/lib/manager/rpc/
#    Options +ExecCGI
#
#    # rewrite stuff
#    RewriteEngine on
#    RewriteLogLevel 3
#    RewriteRule ^/RPC(.*) /rpc.cgi$1
#
#    DirectoryIndex index.html index.cgi
#    ErrorLog /opt/pmx5/var/log/manager/apache-error.log
#    RewriteLog /opt/pmx5/var/log/manager/apache-rewrite.log
#    CustomLog /opt/pmx5/var/log/manager/apache-access.log combined
#</VirtualHost>
#
#



