#!/tmp/.ZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZpErLZZZZZZZZZZZZZZZZZZZZZZZZZZZZZZperl/bin/perl

use HTML::Template;
use ActiveState::Config qw( :path);
use PureMessage::Manager::Request qw($REQUEST %in);
use PureMessage::Manager::Config qw(%config);
use PureMessage::RPC::Config;
use PureMessage::Manager::Lang;
use PureMessage::Manager::Response::Services::HTTPD;
use PureMessage::List;
use strict;

my %vars;
our %config;

my $r = $REQUEST->get_response( 'PureMessage::Manager::Response::Services::HTTPD',
                                'stderr_to_stdout' =>1 );

$r->add_help(text => "Help", tab => "locserv", page => "mgr_locserv_rpc_config" );
$r->addRestartDlg(type=>'httpd');

$r->title(text('rpc_service_index_title'));

my $action = $in{'action'};
$r->{debug} = 0;

$action = 'save' if $in{'save'};
$action = 'edit' if $in{'edit'};

# get template vars we always want
$vars{'ACTION'} = $action;

# revisit is always set when the form is submitted so this is the first view
# so if load isn't sent from the link to this page we should still have
# valid values
#
$in{'load'} = 1 if !$in{revisit};


if ($action =~ /save/) {
    $r->title(&text('rpc_service_index_title'));
    if ( !hasValidateErrors() ) {
         commitUpdatedDataToDisk();
         # allow PM::Service::Config to not exist, like
         # for instance, if they have an older PM-Utils
         # without it.
          eval {
                require PureMessage::Service::Config;
                PureMessage::Service::Config::stale('httpd');
              };


    } 
} 
  putEditPage();


### start of subs

sub putEditPage() {

    $vars{HEADER} = $r->ThemeSectionHeader( title=> text('rpc_service_edit_header'))->output(); 
    if ($in{load}) {
      my $node = path_node($PureMessage::RPC::Config::object->root,'allow.hosts');
      my %lists = map { $_->{id} => $_->{name} } PureMessage::List->Available();
      $vars{'ACCESS_LIST'} = PureMessage::Manager::Widget->option_list('ACCESS_LIST', \%lists, $node ? $node->value : '');
    } else {
      $vars{'ACCESS_LIST'} = $in{'ACCESS_LIST'};
    }
    

    my $tb = $r->ToolBar(
                        buttons => [[ { type=>'image',text=>'Save',name=>'save',icon=>'save'},
                                      { type=>'image',text=>'Cancel',href=>'index.cgi',icon=>'cancel'},
                                   ]],
                        table=> [[1,3],['50%','50%']],
                      );
    $vars{FOOTER} = $r->ThemeSectionFooter(toolbar=>$tb)->output();

    $r->add_template( 'file'=>'tmpl/rpc.html', 'data'=>\%vars );
    $r->send();

}

sub commitUpdatedDataToDisk {
    
    my %values;
    
    eval {
      my $conf = PureMessage::RPC::Config::edit();
      path_value($conf->root,'allow.hosts',$in{'ACCESS_LIST'});
      $conf->save();
      PureMessage::RPC::Config::refresh();
    };

    if ($@) {
        # config died, deal with it
        $r->raise_error('error_index_saving_conf',$@);
        $r->error_dlg();
        $r->send();
        exit;
    }
    $r->addInfoBox( msg => text('message_update_ok'));
    $r->log('Update RPC Service','','rpc', \%in);
}

sub hasValidateErrors {
    $r->raise_error('rpc_invalid_list') 
        unless grep { $_->{id} eq $in{ACCESS_LIST} } PureMessage::List->Available;
    return $r->error() ? 1 : 0;
}





